////////////////////////////////////////////////////////////////////
// CR͂^wKĂ݂悤I
////////////////////////////////////////////////////////////////////
#define _USE_MATH_DEFINES
#include <iostream>
#include <fstream>
#include <sstream>
#include <string>
#include <random>
#include <iomanip>
#include <time.h>
#include <direct.h>
#include <math.h>
#include <omp.h>
#include "FFNNs.h"

#include "Vector3.h"
#include "RK4.h"

////////////////////////////////////////////////////////////////////
// p[^
////////////////////////////////////////////////////////////////////
//͈̔
double t_min = 0;
double t_max = 5.0;
const int TN = 100;

//t
double dt = 0.01;
//x
double v0_min = 0.0;
double v0_max = 30.0;
//ˊpx
double theta_min = 0;
double theta_max = 90;
//d͉x
double g = 10.0;
//
double m = 1.0;
//RW
double beta = 0;
//SRW
double gamma_min = 0.0;
double gamma_max = 2.0;
//RW
double beta_min = 0.0;
double beta_max = 1.0;

double range_x = 10.0;
double range_z = 10.0;
double range_gamma = 2.0;
double range_beta = 1.0;
double range_theta = 90.0;
double range_v0 = 20.0;

////////////////////////////////////////////////////////////////////
// _NX
////////////////////////////////////////////////////////////////////
class Particle : public RK4 {
private:
public:
	//
	double m = 1.0;
	//RW
	double beta = 0.0;
	//SRW
	double gamma = 0.0;
	//d͉x
	double g = 0.0;

	//RXgN^
	Particle() {}
	Particle(double _dt) {
		dt = _dt;
	}
	Particle(double _dt, Vector3& _r, Vector3& _v) {
		dt = _dt;
		r.copy(_r);
		v.copy(_v);
	}
	//xxNgiK{j
	Vector3 A(double t, Vector3& r, Vector3& v) {
		Vector3 output;
		output.x = -beta / m * v.length() * v.x - gamma / m * v.x;
		output.y = -beta / m * v.length() * v.y - gamma / m * v.y;
		output.z = -beta / m * v.length() * v.z - gamma / m * v.z - g;
		return output;
	};
};

////////////////////////////////////////////////////////////////////
// FFNNNXiP̃j[lbg[NjŎgpϐ
////////////////////////////////////////////////////////////////////
std::string post_filename = "_PA_gamma_beta_i100";

//wKȂ̏ꍇ͎̃RgAEgO
//#define NO_LEARNING

//ϑľvZ
int meanN = 1000;

//w
const int layerN = 4;

//j[lbg[N̍\
int structure[layerN] = {
	TN * 4,  //͑w̃j[
	TN * 4, //ԑw̃j[
	TN * 4, //ԑw̃j[
	2   //o͑w̃j[
};
//d݂ƃoCAXq
double weightFactor = 0.5;
double biasFactor = 1.0;

//wK@̎
int typeOfLearning = 0; // 0:Œ, 1:[^@, 2:AdaGrad, 3:RMSprop

//wKp[^
double eta = 0.01;
double mu = 0.5; //1,2,3
double rho = 0.7;//3
double lambda = 0;

//~job`̃TCY
int batch_size = 100;

//wK񐔂̍XV
int delta_iterations = 1000;
//vZlbg[N
const int NNs = 10;

//////////////////////////////////////////////////
// FFNNNX̔hNX
//////////////////////////////////////////////////
class FFNN_coefficient : public FFNN {
private:
public:
	//tM^֐iÓI֐ƂĒ`j
	void calculateTeacherSignal(double* input, double* output) {}
	void calculateTeacherSignal_inverse(double* output, double* input) {}
	//wKpinputf[^@w肷֐
	void defineInput(int epoch, int batch) {

		double beta = beta_min + (beta_max - beta_min) * double(batch)/ double(batch_size);

		double gamma = gamma_min + (gamma_max - gamma_min) * rand_real_0_1(mt);
		double theta = theta_min + (theta_max - theta_min) * rand_real_0_1(mt);
		double v0 = v0_min + (v0_max - v0_min) * rand_real_0_1(mt);

		//QNb^IuWFNg̐
		Particle particle(dt);
		//ʒuxNgƑxxNg
		particle.r.set(0, 0, 0);
		particle.v.set(v0 * cos(theta/180.0*M_PI), 0, v0 * sin(theta / 180.0*M_PI));
		particle.m = m;
		particle.beta = beta;
		particle.gamma = gamma;
		particle.g = g;

//		std::cout << gamma << " " << theta  << std::endl;


		int N = round((t_max - t_min) / dt);
		for (int i = 0; i <= N; i++) {
			double t = i * dt;

			//vZʂ̏o
			if ( i%(N/TN)==0 ) {
				int nx = i / (N / TN);
				int nz = i / (N / TN) + TN/2;
				input[nx] = particle.r.x / range_x;
				input[nz] = particle.r.z / range_z;
				input[nx+ TN] = particle.v.x / range_v0;
				input[nz+ TN*3/2] = particle.v.z / range_v0;


//				std::cout << nx  << " " << nz << " " << particle.r.x << " " << particle.r.z << std::endl;

			}

			//QENb^@ɂ鎞ԔW
			particle.timeEvolution(dt);

			//ʒu̍XV
			particle.r = particle.r + particle.dr;
			//x̍XV
			particle.v = particle.v + particle.dv;
		}

		teacherSignalOutput[0] = gamma / range_gamma;
		teacherSignalOutput[1] = beta / range_beta;
	}
	//ݒ肵͂ɑ΂鑹l̕ςvZ֐
	double getMeanLossValue() {

		double sumLoss = 0;
		for (int i = 0; i < meanN; i++) {

			defineInput(0, i%batch_size);

			//j[lbg[N̏vZiPj
			calculateFeedForward();

			sumLoss += lossFunction();

		}
		sumLoss /= double(meanN);

		return sumLoss;
	}
};
//////////////////////////////////////////////////
// FFNNsNX̔hNX
//////////////////////////////////////////////////
class FFNNs_coefficient : public FFNNs {
private:
public:

	FFNNs_coefficient(int _NNs, int _layerN, int* _structure){
	
		init(_NNs, _layerN, _structure);
	
	}
	void initFFNN() {
		nns = new FFNN_coefficient[NNs];
	}
};

int main(void) {
	std::random_device rnd; //񌈒Iȗ
	std::mt19937 mt;        //32rbgŃZkEcCX^
	std::uniform_real_distribution<> rand_real_0_1;
	unsigned int seed = (unsigned)time(NULL) + clock();
	mt.seed(seed);

	// t@Co̓Xg[̏
	std::ofstream ofs, ofs_L, ofs_weight;
	std::ifstream if_weight;

	//vZێp
	std::ostringstream information;
	information << "#############################" << std::endl;
	information << "## CR͂^̊wKiwKj" << std::endl;
	information << "#############################" << std::endl;
	information << "##jbgF";
	for (int i = 0; i < layerN; i++) {
		information << structure[i];
		if (i != layerN-1) information << "-";
	}
	information << std::endl;
	information << "##wK@F" << typeOfLearning << std::endl;
	information << "##ob`F" << batch_size << std::endl;
	information << "##etaF" << eta << std::endl;
	information << "##muF" << mu << std::endl;
	information << "##rhoF" << rho << std::endl;
	information << "##lambdaF" << lambda << std::endl;
	information << "##weightFactorF" << weightFactor << std::endl;
	information << "##biasFactorF" << biasFactor << std::endl;

	//t@Cwp
	std::ostringstream _filename;
	_filename << "FFNN_F_type" << typeOfLearning << "_";
	for (int i = 0; i < layerN; i++) {
		_filename << structure[i];
		if (i != layerN-1) _filename << "-";
	}
	_filename << post_filename;
	//tH_̐
	_mkdir("output");
	//t@C̐ݒ
	std::ostringstream filename;
	filename << "output/" << _filename.str() << ".txt";
	//o̓Xg[ɂt@CI[v
	ofs.open(filename.str());
	ofs << information.str();
	
#ifndef NO_LEARNING
	//̏
	filename.str("");
	filename.clear(std::stringstream::goodbit);
	//t@C̐ݒ
	filename << "output/" << _filename.str() << "_epoch.txt";
	//o̓Xg[ɂt@CI[v
	ofs_L.open(filename.str());
	ofs_L << information.str();
	//̏
	filename.str("");
	filename.clear(std::stringstream::goodbit);
	//t@C̐ݒ
	filename << "output/" << _filename.str() << "_weight.txt";
	//o̓Xg[ɂt@CI[v
	ofs_weight.open(filename.str());
	ofs_weight << information.str();

#else
	//̏
	filename.str("");
	filename.clear(std::stringstream::goodbit);
	//t@C̐ݒ
	filename << "input/FFNN_F_type0_200-200-1_PA_weight.txt";
	//o̓Xg[ɂt@CI[v
	if_weight.open(filename.str());
#endif

	FFNNs_coefficient ffnns_coefficient(NNs, layerN, structure);
	ffnns_coefficient.eta = eta;
	ffnns_coefficient.batch_size = batch_size;
	ffnns_coefficient.adoptFactor(weightFactor, biasFactor);
	ffnns_coefficient.typeOfLearning = typeOfLearning;
	ffnns_coefficient.mu = mu;
	ffnns_coefficient.rho = rho;
	ffnns_coefficient.lambda = lambda;

#ifndef NO_LEARNING
	//vJn
	clock_t start = clock();
	int ms, d, h, m, s;
	ofs_L << "####################" << std::endl;
	ofs_L << "#x:G|bN" << std::endl;
	ofs_L << "#y:l" << std::endl;
	ofs_L << "#showLines: false false false false false" << std::endl;
	ofs_L << "#showMarkers: true true true true true" << std::endl;
	ofs_L << "#set logscale y" << std::endl;
	ofs_L << "#xrange:0 " << delta_iterations*100 << " " << delta_iterations * 10 << std::endl;
	for (int epochN = 0; epochN <= 100; epochN++) {


		if (epochN == 0) ffnns_coefficient.iterations = 0;
		else ffnns_coefficient.iterations = delta_iterations;

		ffnns_coefficient.learnNetworks();
		ffnns_coefficient.updateLowerToHigher();

		double top1 = ffnns_coefficient.lossVales[ffnns_coefficient.ranking[0]];
		double top2 = ffnns_coefficient.lossVales[ffnns_coefficient.ranking[1]];
		double top3 = ffnns_coefficient.lossVales[ffnns_coefficient.ranking[2]];
		double top4 = ffnns_coefficient.lossVales[ffnns_coefficient.ranking[3]];
		double top5 = ffnns_coefficient.lossVales[ffnns_coefficient.ranking[4]];

		ofs_L << delta_iterations * epochN << " " << top1 << " " << top2 << " " << top3 << " " << top4 << " " << top5 << std::endl;
		std::cout << "t = "<< delta_iterations * epochN << std::endl;

		//vI
		clock_t end = clock();
		ms = end - start;
		d = ms / (1000 * 60 * 60 * 24);
		ms -= d * (1000 * 60 * 60 * 24);
		h = ms / (1000 * 60 * 60);
		ms -= h * (1000 * 60 * 60);
		m = ms / (1000 * 60);
		ms -= m * (1000 * 60);
		s = ms / 1000;
		ms -= s * 1000;
		std::cout << "vZԁF" << d << "" << h << "" << m << "" << s << "." << ms << "b" << std::endl;

	}


	ofs_L << "####################" << std::endl;
	ofs_L << "#vZԁF" << d << "" << h << "" << m << "" << s << "." << ms <<"b"  << std::endl;
	ofs_L.close();

#else
	//wKς݃lbg[N̓ǂݍ
	ffnns_coefficient.readDumpNetwork( if_weight );
	ffnns_coefficient.loadNetwork();
	if_weight.close();
#endif

	ofs << "####################" << std::endl;
	ofs << "#x:ˊpx" << std::endl;
	ofs << "#y:SRW" << std::endl;
	ofs << "#showLines: true false true false true false true false" << std::endl;
	ofs << "#showMarkers: false true false true false true false true" << std::endl;
	ofs << "#xrange:0 90 10" << std::endl;

	double *teacherSignalOutput = new double[structure[layerN-1]];
	double *output1 = new double[structure[layerN-1]];
	double *input1 = new double[structure[0]];
	double *output2 = new double[structure[layerN - 1]];
	double *input2 = new double[structure[0]];
	double *output3 = new double[structure[layerN - 1]];
	double *input3 = new double[structure[0]];
	double *output4 = new double[structure[layerN - 1]];
	double *input4 = new double[structure[0]];
	double sum = 0;

	double gamma1 = 0.0;
	double gamma2 = 0.5;
	double gamma3 = 1.0;
	double gamma4 = 1.5;

	double beta = 0.5;

	double v0 = 20.0;

	for (int nx = 0; nx <= 100; nx++) {
		double theta = theta_min + (theta_max - theta_min) * double(nx) / 100.0;

		{
			//QNb^IuWFNg̐
			Particle particle(dt);
			//ʒuxNgƑxxNg
			particle.r.set(0, 0, 0);
			particle.v.set(v0 * cos(theta / 180.0*M_PI), 0, v0 * sin(theta / 180.0*M_PI));
			particle.m = m;
			particle.beta = beta;
			particle.gamma = gamma1;
			particle.g = g;

			int N = round((t_max - t_min) / dt);
			for (int i = 0; i <= N; i++) {
				double t = i * dt;

				//vZʂ̏o
				if (i % (N / TN) == 0) {
					int nx = i / (N / TN);
					int nz = i / (N / TN) + TN / 2;
					input1[nx] = particle.r.x / range_x;
					input1[nz] = particle.r.z / range_z;
				}
				//QENb^@ɂ鎞ԔW
				particle.timeEvolution(dt);
				//ʒu̍XV
				particle.r = particle.r + particle.dr;
				//x̍XV
				particle.v = particle.v + particle.dv;
			}
		}
		{
			//QNb^IuWFNg̐
			Particle particle(dt);
			//ʒuxNgƑxxNg
			particle.r.set(0, 0, 0);
			particle.v.set(v0 * cos(theta / 180.0*M_PI), 0, v0 * sin(theta / 180.0*M_PI));
			particle.m = m;
			particle.beta = beta;
			particle.gamma = gamma2;
			particle.g = g;

			int N = round((t_max - t_min) / dt);
			for (int i = 0; i <= N; i++) {
				double t = i * dt;

				//vZʂ̏o
				if (i % (N / TN) == 0) {
					int nx = i / (N / TN);
					int nz = i / (N / TN) + TN / 2;
					input2[nx] = particle.r.x / range_x;
					input2[nz] = particle.r.z / range_z;
				}
				//QENb^@ɂ鎞ԔW
				particle.timeEvolution(dt);
				//ʒu̍XV
				particle.r = particle.r + particle.dr;
				//x̍XV
				particle.v = particle.v + particle.dv;
			}
		}
		{
			//QNb^IuWFNg̐
			Particle particle(dt);
			//ʒuxNgƑxxNg
			particle.r.set(0, 0, 0);
			particle.v.set(v0 * cos(theta / 180.0*M_PI), 0, v0 * sin(theta / 180.0*M_PI));
			particle.m = m;
			particle.beta = beta;
			particle.gamma = gamma3;
			particle.g = g;

			int N = round((t_max - t_min) / dt);
			for (int i = 0; i <= N; i++) {
				double t = i * dt;

				//vZʂ̏o
				if (i % (N / TN) == 0) {
					int nx = i / (N / TN);
					int nz = i / (N / TN) + TN / 2;
					input3[nx] = particle.r.x / range_x;
					input3[nz] = particle.r.z / range_z;
				}
				//QENb^@ɂ鎞ԔW
				particle.timeEvolution(dt);
				//ʒu̍XV
				particle.r = particle.r + particle.dr;
				//x̍XV
				particle.v = particle.v + particle.dv;
			}
		}
		{
			//QNb^IuWFNg̐
			Particle particle(dt);
			//ʒuxNgƑxxNg
			particle.r.set(0, 0, 0);
			particle.v.set(v0 * cos(theta / 180.0*M_PI), 0, v0 * sin(theta / 180.0*M_PI));
			particle.m = m;
			particle.beta = beta;
			particle.gamma = gamma4;
			particle.g = g;

			int N = round((t_max - t_min) / dt);
			for (int i = 0; i <= N; i++) {
				double t = i * dt;

				//vZʂ̏o
				if (i % (N / TN) == 0) {
					int nx = i / (N / TN);
					int nz = i / (N / TN) + TN / 2;
					input4[nx] = particle.r.x / range_x;
					input4[nz] = particle.r.z / range_z;
				}
				//QENb^@ɂ鎞ԔW
				particle.timeEvolution(dt);
				//ʒu̍XV
				particle.r = particle.r + particle.dr;
				//x̍XV
				particle.v = particle.v + particle.dv;
			}
		}
		ffnns_coefficient.calculateByBestNeuralNetwork(input1, output1);
		ffnns_coefficient.calculateByBestNeuralNetwork(input2, output2);
		ffnns_coefficient.calculateByBestNeuralNetwork(input3, output3);
		ffnns_coefficient.calculateByBestNeuralNetwork(input4, output4);


		ofs << theta << " " << gamma1 << " " << output1[0] * range_gamma << " " << gamma2 << " " << output2[0] * range_gamma <<" " << gamma3 << " " << output3[0] * range_gamma << " " << gamma4 << " " << output4[0] * range_gamma << std::endl;

		sum += pow(gamma1 - output1[0] * range_gamma, 2) / 2.0 / 100.0 / 4.0;
		sum += pow(gamma2 - output2[0] * range_gamma, 2) / 2.0 / 100.0 / 4.0;
		sum += pow(gamma3 - output3[0] * range_gamma, 2) / 2.0 / 100.0 / 4.0;
		sum += pow(gamma4 - output4[0] * range_gamma, 2) / 2.0 / 100.0 / 4.0;
	}
	std::cout << "Loss=" << sum << std::endl;


	ofs.close();

	#ifndef NO_LEARNING
	ffnns_coefficient.dumpNetwork( ofs_weight );
	ofs_weight.close();
	#endif
	std::cout << "finish" << std::endl;
	int b;
	std::cin >> b;
	return b;
}

/*
gccRpC
g++ -c Matrix.cpp -std=c++14 -O2
g++ -c FFNN.cpp -std=c++14 -O2 -fopenmp
g++ -c FFNNs.cpp -std=c++14 -O2 -fopenmp
g++ -c main.cpp -std=c++14 -O2 -fopenmp
g++ main.o Matrix.o FFNN.o FFNNs.o -fopenmp


g++ -c Matrix.cpp -std=c++14 -O2
g++ -c FFNN.cpp -std=c++14 -O2
g++ -c FFNNs.cpp -std=c++14 -O2
g++ -c main.cpp -std=c++14 -O2
g++ main.o Matrix.o FFNN.o FFNNs.o
*/